
#include <boost/operators.hpp>
#include <boost/optional.hpp>
#include <boost/noncopyable.hpp>

typedef unsigned __int64 my_ulonglong;

class  Identifier
    : boost::totally_ordered<Identifier>
{
public:

    class BigInt
        : boost::totally_ordered<BigInt>
    {
    public:
        typedef my_ulonglong TValueType;

        explicit BigInt(TValueType = 0);

    private:
        TValueType m_Value;
    };

private:

    boost::optional<BigInt> m_Var;
};

class bla : public boost::noncopyable
{
public:
    typedef Identifier::BigInt TBigInt;

    void explode(boost::optional<TBigInt> param = boost::optional<TBigInt>()) const;
};
